#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"


#include <limits.h>
#include <sys/dos.h>


MODULE = DOS	PACKAGE = DOS	PREFIX = _dos


int
_dos_getassign(buff1,buff2)
	char *	buff1
	char *	buff2 = sv_grow(ST(1),PATH_MAX+1);
    CLEANUP:
	sv_setpv(ST(1),buff2);

int
_dos_makeassign(buff1,buff2,mode)
	char *	buff1
	char *	buff2
	int	mode

int
_dos_rassign(buff)
	char *	buff


int
_dos_breakck(mode)
	int	mode


int
_dos_change_pr()


int
_dos_chdir(file)
	char *	file


int
_dos_chgdrv(drive)
	int	drive


int
_dos_chmod(name,mode)
	char *	name
	int	mode


int
_dos_cinsns()


int
_dos_cominp()


int
_dos_common_ck(name)
	char *	name

int
_dos_common_del(name)
	char *	name

int
_dos_common_fre(name,pos,id_psp,len)
	char *	name
	int	pos
	int	id_psp
	int	len

int
_dos_common_lk(name,pos,id_psp,len)
	char *	name
	int	pos
	int	id_psp
	int	len

int
_dos_common_rd(name,pos,buff,len)
	char *	name
	int	pos
	int	len
	char *	buff = sv_grow(ST(2),len);
    CLEANUP:
	sv_setpvn(ST(2),buff,len);

int
_dos_common_wt(name,pos,buff,len)
	char *	name
	int	pos
	char *	buff
	int	len


int
_dos_comout(code)
	int	code


int
_dos_c_putc(code)
	int	code

int
_dos_c_print(message)
	char *	message

int
_dos_c_color(atr)
	int	atr

int
_dos_c_locate(x,y)
	int	x
	int	y

int
_dos_c_down_s()

int
_dos_c_up_s()

int
_dos_c_down(cnt)
	int	cnt

int
_dos_c_up(cnt)
	int	cnt

int
_dos_c_right(cnt)
	int	cnt

int
_dos_c_left(cnt)
	int	cnt

int
_dos_c_cls_ed()

int
_dos_c_cls_st()

int
_dos_c_cls_al()

int
_dos_c_era_ed()

int
_dos_c_era_st()

int
_dos_c_era_al()

int
_dos_c_ins(cnt)
	int	cnt

int
_dos_c_del(cnt)
	int	cnt

int
_dos_c_fnkmod(mode)
	int	mode

int
_dos_c_window(ys,yl)
	int	ys
	int	yl

int
_dos_c_width(mode)
	int	mode

int
_dos_c_curon()

int
_dos_c_curoff()


int
_dos_consns()


int
_dos_coutsns()


int
_dos_create(file,atr)
	char *	file
	int	atr


void
_dos_ctlabort()


int
_dos_curdir(drive,buff)
	int	drive
	char *	buff = sv_grow(ST(1),PATH_MAX+1);
    CLEANUP:
	sv_setpv(ST(2),buff);


int
_dos_curdrv()


int
_dos_delete(file)
	char *	file


int
_dos_diskred(buffer,drive,sector,seclen)
	char *	buffer = NO_INIT
	int	drive
	int	sector
	int	seclen
    CODE:
	struct _dpbptr dpbbuf;
	int r;
	r = _dos_getdpb(drive,&dpbbuf);
	if(r<0)
		r = 1024 * seclen;
	else
		r = dpbbuf.byte * seclen;
	buffer = sv_grow(ST(0),r);
	RETVAL = _dos_diskred(buffer,drive,sector,seclen);
    CLEANUP:
	ST(1) = ST(0);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0),RETVAL);
	sv_setpvn(ST(1),buffer,r);


int
_dos_diskwrt(buffer,drive,sector,seclen)
	char *	buffer
	int	drive
	int	sector
	int	seclen


int
_dos_drvctrl(mode,drive)
	int	mode
	int	drive


int
_dos_drvxchg(old,new)
	int	old
	int	new


int
_dos_dskfre(drive,buff)
	int	drive
	struct _freeinf *	buff = (struct _freeinf *)sv_grow(ST(1),sizeof(struct _freeinf));
    CLEANUP:
	sv_setpvn(ST(1),(char *)buff,sizeof(struct _freeinf));


int
_dos_dup(fildes)
	int	fildes


int
_dos_dup0(fildes,newdes)
	int	fildes
	int	newdes


int
_dos_dup2(fildes,newdes)
	int	fildes
	int	newdes


void
_dos_errabort()


int
_dos_fatchk(file,buff)
	char *	file
	unsigned short *	buff = (short *)sv_grow(ST(1),2+1024*4+2);
    CLEANUP:
	if(RETVAL>=0){
		sv_setpvn(ST(1),(char *)buff,RETVAL);
	}else
		sv_setpvn(ST(1),(char *)buff,0);


int
_dos_fatchk2(file,buff,len)
	char *	file
	int	len
	unsigned short *	buff = (short *)sv_grow(ST(1),len);
    CLEANUP:
	if(RETVAL>=0){
		sv_setpvn(ST(1),(char *)buff,RETVAL);
	}else
		sv_setpvn(ST(1),(char *)buff,0);


int
_dos_fflush()


int
_dos_fgetc(fildes)
	int	fildes


int
_dos_fgets(inpptr,fildes)
	struct _inpptr *	inpptr = (struct _inpptr *)sv_grow(ST(0),sizeof(struct _inpptr));
	int	fildes
    CODE:
	RETVAL = _dos_fgets(inpptr,fildes);
    CLEANUP:
	ST(1) = ST(0);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0),RETVAL);
	if(RETVAL>=0){
		inpptr->buffer[RETVAL] = '\0';
		sv_setpvn(ST(1),(char *)inpptr,
			sizeof(inpptr->max)+sizeof(inpptr->length)+RETVAL+1);
	}else
		sv_setpvn(ST(1),(char *)inpptr,
			sizeof(inpptr->max)+sizeof(inpptr->length));


int
_dos_filedate(fildes,filedate)
	int	fildes
	int	filedate


int
_dos_files(buff,file,atr)
	struct _filbuf *	buff = (struct _filbuf *)sv_grow(ST(0),sizeof(struct _filbuf));
	char *	file
	int	atr
    CODE:
	RETVAL = _dos_files(buff,file,atr);
    CLEANUP:
	ST(1) = ST(0);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0),RETVAL);
	sv_setpvn(ST(1),(char *)buff,sizeof(struct _filbuf));


int
_dos_fnckeygt(fno,buff)
	int	fno
	char *	buff = NO_INIT
    CODE:
	int	bufsiz;

	if(fno==0){
		bufsiz = 720;
	}else if(fno<=20){
		bufsiz = 32;
	}else if(fno<=32){
		bufsiz = 6;
	}else{
		bufsiz = 720;
	}

	buff = sv_grow(ST(1),bufsiz);
	RETVAL = _dos_fnckeygt(fno,buff);
    CLEANUP:
	ST(0) = sv_newmortal();
	sv_setiv(ST(0),RETVAL);
	sv_setpvn(ST(1),(char *)buff,bufsiz);


int
_dos_fnckeyst(fno,buff)
	int	fno
	char *	buff


int
_dos_fputc(code,fildes)
	int	code
	int	fildes


int
_dos_fputs(message,fildes)
	char *	message
	int	fildes


int
_dos_get_pr(id,buff)
	int	id
	struct _prcptr *	buff = (struct _prcptr *)sv_grow(ST(0),sizeof(struct _prcptr));
    CLEANUP:
	sv_setpvn((SV*)ST(1),(char *)buff,sizeof(struct _prcptr));


int
_dos_getc()


int
_dos_getchar()


int
_dos_getdate()


int
_dos_getdpb(drive,dpbptr)
	int	drive
	struct _dpbptr *	dpbptr = (struct _dpbptr *)sv_grow(ST(1),sizeof(struct _dpbptr));
    CLEANUP:
	sv_setpvn(ST(1),dpbptr,sizeof(struct _dpbptr));


int
_dos_getenv(name,env,buff)
	char *	name
	char *	env
	char *	buff = sv_grow(ST(2),1024);
    CLEANUP:
	sv_setpv(ST(2),buff);


void *
_dos_getfcb(fildes)
	int	fildes


void *
_dos_getpdb()


int
_dos_gets(inpptr)
	struct _inpptr *	inpptr = (struct _inpptr *)sv_grow(ST(0),sizeof(struct _inpptr));
    CODE:
	RETVAL = _dos_gets(inpptr);
    CLEANUP:
	ST(1) = ST(0);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0),RETVAL);
	if(RETVAL>=0){
		inpptr->buffer[RETVAL] = '\0';
		sv_setpvn(ST(1),(char *)inpptr,
			sizeof(inpptr->max)+sizeof(inpptr->length)+RETVAL+1);
	}else
		sv_setpvn(ST(1),(char *)inpptr,
			sizeof(inpptr->max)+sizeof(inpptr->length));


int
_dos_getss(inpptr)
	struct _inpptr *	inpptr = (struct _inpptr *)sv_grow(ST(0),sizeof(struct _inpptr));
    CODE:
	RETVAL = _dos_getss(inpptr);
    CLEANUP:
	ST(1) = ST(0);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0),RETVAL);
	if(RETVAL>=0){
		inpptr->buffer[RETVAL] = '\0';
		sv_setpvn(ST(1),(char *)inpptr,
			sizeof(inpptr->max)+sizeof(inpptr->length)+RETVAL+1);
	}else
		sv_setpvn(ST(1),(char *)inpptr,
			sizeof(inpptr->max)+sizeof(inpptr->length));


int
_dos_gettim2()


int
_dos_gettime()


int
_dos_hendspic(position)
	int	position

int
_dos_hendspio()

int
_dos_hendspip(position,message)
	int	position
	char *	message

int
_dos_hendspmc()

int
_dos_hendspmo()

int
_dos_hendspmp(position,message)
	int	position
	char *	message

int
_dos_hendspmr(position,message)
	int	position
	char *	message

int
_dos_hendspsc()

int
_dos_hendspso()

int
_dos_hendspsp(position,message)
	int	position
	char *	message

int
_dos_hendspsr(position,message)
	int	position
	char *	message


void *
_dos_importlnenv()


void *
_dos_indosflg()


int
_dos_inkey()


int
_dos_inpout(code)
	int	code


void *
_dos_intvcg(intno)
	int	intno


void *
_dos_intvcs(intno,jobaddr)
	int	intno
	void *	jobaddr


int
_dos_ioctrlgt(fno)
	int	fno

int
_dos_ioctrlst(fno,data)
	int	fno
	int	data

int
_dos_ioctrlrh(fno,buffer,size)
	int	fno
	int	size
	char *	buffer = sv_grow(ST(1),size);
    CLEANUP:
	sv_setpvn(ST(1),buffer,size);

int
_dos_ioctrlwh(fno,buffer,size)
	int	fno
	char *	buffer
	int	size

int
_dos_ioctrlrd(drive,buffer,size)
	int	drive
	int	size
	char *	buffer = sv_grow(ST(1),size);
    CLEANUP:
	sv_setpvn(ST(1),buffer,size);

int
_dos_ioctrlwd(drive,buffer,size)
	int	drive
	char *	buffer
	int	size

int
_dos_ioctrlis(fno)
	int	fno

int
_dos_ioctrlos(fno)
	int	fno

int
_dos_ioctrldvctl(drive,f_code,buff)
	int	drive
	int	f_code
	char *	buff

int
_dos_ioctrldvgt(drive)
	int	drive

int
_dos_ioctrlfdctl(fno,f_code,buff)
	int	fno
	int	f_code
	char *	buff

int
_dos_ioctrlfdgt(fno)
	int	fno

int
_dos_ioctrlrtset(count,time)
	int	count
	int	time


int
_dos_k_keyinp()

int
_dos_k_keysns()

int
_dos_k_sftsns()

int
_dos_k_keybit(group)
	int	group

int
_dos_k_insmod(mode)
	int	mode


int
_dos_keysns()


int
_dos_kflushgc()

int
_dos_kflushgp()

int
_dos_kflushgs(inpptr)
	struct _inpptr *	inpptr = (struct _inpptr *)sv_grow(ST(0),sizeof(struct _inpptr));
    CODE:
	RETVAL = _dos_kflushgs(inpptr);
    CLEANUP:
	ST(1) = ST(0);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0),RETVAL);
	if(RETVAL>=0){
		inpptr->buffer[RETVAL] = '\0';
		sv_setpvn(ST(1),(char *)inpptr,
			sizeof(inpptr->max)+sizeof(inpptr->length)+RETVAL+1);
	}else
		sv_setpvn(ST(1),(char *)inpptr,
			sizeof(inpptr->max)+sizeof(inpptr->length));

int
_dos_kflushin()

int
_dos_kflushio(code)
	int	code


int
_dos_lfiles(buff,file,atr)
	struct _filbuf *	buff = (struct _filbuf *)sv_grow(ST(0),sizeof(struct _filbuf));
	char *	file
	int	atr
    CODE:
	RETVAL = _dos_lfiles(buff,file,atr);
    CLEANUP:
	ST(1) = ST(0);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0),RETVAL);
	sv_setpvn(ST(1),(char *)buff,sizeof(struct _filbuf));


int
_dos_lock(fildes,offset,len)
	int	fildes
	int	offset
	int	len


int
_dos_unlock(fildes,offset,len)
	int	fildes
	int	offset
	int	len


int
_dos_maketmp(file,atr)
	char *	file
	int	atr
    CODE:
	RETVAL = _dos_maketmp(file,atr);
    CLEANUP:
	ST(1) = ST(0);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0),RETVAL);
	sv_setpv(ST(1),file);


void *
_dos_malloc(size)
	int	size


void *
_dos_malloc2(mode,size)
	int	mode
	int	size


int
_dos_memcpy(s_addr,d_addr,mode)
	char *	s_addr
	char *	d_addr
	int	mode


int
_dos_mfree(memptr)
	char *	memptr


int
_dos_mkdir(file)
	char *	file


int
_dos_move(oldfile,newfile)
	char *	oldfile
	char *	newfile


int
_dos_nameck(file,buff)
	char *	file
	struct _nameckbuf *	buff = (struct _nameckbuf *)sv_grow(ST(1),sizeof(struct _nameckbuf));
    CLEANUP:
	sv_setpvn(ST(1),(char *)buff,sizeof(struct _nameckbuf));


int
_dos_namests(file,buff)
	char *	file
	struct _namestbuf *	buff = (struct _namestbuf *)sv_grow(ST(1),sizeof(struct _namestbuf));
    CLEANUP:
	sv_setpvn(ST(1),(char *)buff,sizeof(struct _namestbuf));


int
_dos_newfile(file,atr)
	char *	file
	int	atr


int
_dos_nfiles(buff)
	struct _filbuf *	buff = (struct _filbuf *)sv_grow(ST(0),sizeof(struct _filbuf));
    CODE:
	RETVAL = _dos_nfiles(buff);
    CLEANUP:
	ST(1) = ST(0);
	ST(0) = sv_newmortal();
	sv_setiv(ST(0),RETVAL);
	sv_setpvn(ST(1),(char *)buff,sizeof(struct _filbuf));


int
_dos_open(file,mode)
	char *	file
	int	mode


int
_dos_print(msgptr)
	char *	msgptr


int
_dos_prnout(code)
	int	code


int
_dos_prnsns()


int
_dos_pspset(pspaddr)
	char *	pspaddr


int
_dos_putchar(code)
	int	code


int
_dos_read(fildes,buff,size)
	int	fildes
	int	size
	char *	buff = sv_grow(ST(1),size);
    CLEANUP:
	if(RETVAL>=0){
		sv_setpvn(ST(1),buff,RETVAL);
	}else
		sv_setpvn(ST(1),buff,0);


int
_dos_readlink(linkpath,namebuf,buflen)
	char *	linkpath
	int	buflen
	char *	namebuf = sv_grow(ST(1),buflen);
    CLEANUP:
	sv_setpv(ST(1),namebuf);


int
_dos_rename(oldfile,newfile)
	char *	oldfile
	char *	newfile


int
_dos_rmdir(file)
	char *	file


int
_dos_s_malloc(mode,size)
	int	mode
	int	size


int
_dos_s_mfree(memptr)
	char *	memptr


int
_dos_s_process(id,start,size,i_len)
	int	id
	int	start
	int	size
	int	i_len


int
_dos_seek(fildes,offset,mode)
	int	fildes
	int	offset
	int	mode


int
_dos_send_pr(my_id,your_id,command,buff,len)
	int	my_id
	int	your_id
	int	command
	char *	buff
	int	len


int
_dos_setblock(memptr,newsize)
	char *	memptr
	int	newsize


int
_dos_setdate(date)
	int	date


int
_dos_setenv(name,env,buff)
	char *	name
	char *	env
	char *	buff


int
_dos_setpdb(pdbaddr)
	char *	pdbaddr


int
_dos_settim2(time)
	int	time


int
_dos_settime(time)
	int	time


int
_dos_sleep_pr(time)
	int	time


int
_dos_suspend_pr(id)
	int	id


int
_dos_symlink(src,dst)
	char *	src
	char *	dst


int
_dos_time_pr()


int
_dos_verify(flag)
	int	flag


int
_dos_verifyg()


int
_dos_vernum()


int
_dos_wait()


int
_dos_write(fildes,buff,size)
	int	fildes
	char *	buff
	int	size


